#!/usr/bin/perl
#$| = 1;
###############################################################################
# 設定ここから

our ($begintime) = 8;                    # 予約の開始時刻
our ($closetime) = 22;                   # 予約の終了時刻
our ($ban)       = 24;                   # 翌月予約解禁日
our ($title)     = '会議室予約';    # ホームページのタイトル

# 設定ここまで
#
# 本スクリプトはフリーですが著作権は放棄しておりません。著作権と広告リンクは消さないで。
# 決まり事ですが万が一、本スクリプトが原因で損害が生じても当方は責任は一切持てません。
# 十分評価した上で自己責任で使用してください。
#
# 改訂履歴
# 1.00	1999/12/19	初版発行
# 1.01	2000/01/25	連続入力可能なようにクッキーに対応。管理者ページでの未記入によるエラーを修正
# 1.02	2000/02/01	IE3.0でのクッキー文字化けを避けるためにＩＥ3.0のアクセスを拒否させた。#
# 2.00  2011/09/29  IE3.0って一体いつの事だか（笑）フレームやめて ほとんど書き直し。
#
###############################################################################
use Time::Local;
use File::Copy;
require './jcode.pl';
&init_form;
our (%form);
our ($flag)      = $form{'flag'};
our ($targetDay) = $form{'targetDay'};
our ($targetID)  = $form{'targetID'};
our ($delID)     = $form{'delID'};
our ($st_h)      = $form{'st_h'};
our ($st_m)      = $form{'st_m'};
our ($fn_h)      = $form{'fn_h'};
our ($fn_m)      = $form{'fn_m'};
our ($inputpw)   = $form{'inputpw'};
our ($mngrpw)    = $form{'mngrpw'};
our ($reserver)  = $form{'reserver'};
our ($tel)       = $form{'tel'};

#our ($num)       = $form{'num'};
our (@itemlist) = &open_file("./list.cgi");
our ($today)    = &getToday;
our (%roomInfo);
our ($cookiereserver);
our ($cookietel);
###############################################################################
$targetDay = $today if ( $targetDay eq '' );

&initialize;
&main_proc;
&footer;

exit(0);

###############################################################################
# <summary>
#   初期化
# </summary>
# <remarks></remarks>
###############################################################################
sub initialize {
	foreach my $line (@itemlist) {
		chomp($line);
		my ($id) = ( split( /,/, $line ) )[0];
		$roomInfo{$id} = $line;
	}

}

###############################################################################
# <summary>
#   メインスクリプト
# </summary>
# <remarks></remarks>
###############################################################################
sub main_proc {

	print "Content-type: text/html\n";
	if ( $flag eq 'reserve' ) {
		my ($cookie) = "$reserver\,$tel\,";
		print "Set-Cookie: RRSystem=$cookie; expires=Thursday, 31-Dec-2020 23:59:59 GMT\n\n";
	}
	else {
		print "\n";
	}
	&header;

	# タイトルフレーム
	print "<div class=\"outer\">\n";
	print "  <div class=\"titlebox\">\n";
	print "    <h1>$title</h1>\n";
	print "  </div>\n";

	# 左フレーム
	print "  <div class=\"leftbox\">\n";
	&show_calendar;
	print "    <br />\n";
	&show_manageinput;
	print "  </div>\n";

	# 右フレーム
	print "  <div class=\"rightbox\">\n";
	if ( $flag eq 'reservebox' ) {
		print "    <a href=\"./\">Topへ戻る</a>\n";
		print "    <br />\n";
		print "    <br />\n";

		# 部屋表示
		my (@tgtLines) = &show_rooms;
		print "    <br />\n";

		# 詳細表示
		&show_detail(@tgtLines);
		print "    <br />\n";

		# 予約入力フォーム表示
		&show_inputform;
	}
	elsif ( $flag eq 'admin' ) {
		my ($roompw) = ( split( /,/, $roomInfo{$targetID} ) )[3];
		if ( $mngrpw eq $roompw ) {
			print "    <div><span class=\"errormsg\">管理者モード</span></div>\n";
			print "    <a href=\"./\">Topへ戻る</a>\n";
			&show_daypick;
		}
		else {
			print "    <div><span class=\"errormsg\">パスワードが違います。</span></div>\n";
		}
	}
	elsif ( $flag eq "formadmin" ) {
		print "    <div><span class=\"errormsg\">管理者モード</span></div>\n";
		print "    <a href=\"./\">Topへ戻る</a>\n";
		&show_daypick;
		&show_rooms;
		print "    <br />\n";

		# 予約入力フォーム表示
		&show_inputform;
	}
	elsif ( $flag eq 'reserve' ) {

		# データ書き込み
		&write_data;
		print "    <a href=\"./\">Topへ戻る</a>\n";
		print "    <br />\n";

		# 管理者モードの時
		my ($roompw) = ( split( /,/, $roomInfo{$targetID} ) )[3];
		if ( $mngrpw eq $roompw ) {
			print "    <div><span class=\"errormsg\">管理者モード</span></div>\n";
			&show_daypick;
		}

		# 部屋表示
		my (@tgtLines) = &show_rooms;
		print "    <br />\n";

		# 詳細表示
		&show_detail(@tgtLines);
		print "    <br />\n";

		# 予約入力フォーム表示
		&show_inputform;
	}
	elsif ( $flag eq 'cancel' ) {
		&delete_data;
		print "    <a href=\"./\">Topへ戻る</a>\n";
		print "    <br />\n";

		# 部屋表示
		my (@tgtLines) = &show_rooms;
		print "    <br />\n";

		# 詳細表示
		&show_detail(@tgtLines);
		print "    <br />\n";

		# 予約入力フォーム表示
		&show_inputform;
	}
	else {
		&show_rooms;
	}
	&show_iframe;
	print "  </div>\n";
	print "</div>\n";
}

###############################################################################
# <summary>
#   予約一覧
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub show_rooms {

	my (@retlines);
	print "    <div>\n";
	print "      <h2><span class=\"rightcaption\">" . substr( $targetDay, 0, 4 ) . "年" . substr( $targetDay, 4, 2 ) . "月" . substr( $targetDay, 6, 2 ) . "日 予約状況</span></h2>\n";
	print "      <table class=\"reserve\">\n";
	print "        <tr>\n";
	print "          <th class=\"cap\" style=\"width: 120px;\"><br /></th>\n";

	# 時刻リスト
	my ($i);
	for ( $i = $begintime ; $i < $closetime ; $i++ ) {
		print "          <th colspan=\"2\" class=\"cap\">$i</th>\n";
	}
	print "        </tr>\n";

	my (@reservelines);
	if ( $targetID ne '' ) {

		# １部屋のとき
		@reservelines = &open_file( "./data/" . $targetID . ".dat" );
		@retlines = &show_roomline( $targetID, @reservelines );
	}
	else {

		# 各部屋
		foreach (@itemlist) {
			my (@tmp) = split( /,/, $_ );
			@reservelines = &open_file( "./data/" . $tmp[0] . ".dat" );
			&show_roomline( $tmp[0], @reservelines );
		}
	}
	print "      </table> \n";
	print "    </div>\n";
	return @retlines;
}
###############################################################################
# <summary>
#   予約ライン表示
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub show_roomline {

	my ( $id, @reservelines ) = @_;
	my ($thismon) = substr( $today, 4, 2 );
	my ($thisday) = substr( $today, 6, 2 );
	my ($roomName) = ( split( /,/, $roomInfo{$id} ) )[1];

	print "        <tr>\n";
	print "          <th class=\"cap\">\n";
	if ( ( $thisday >= $ban ) || ( substr( $targetDay, 4, 2 ) eq $thismon ) ) {
		print "            <form method=\"POST\" action=\"./\">\n";
		print "              <input type=\"submit\" value=\"$roomName\" class=\"linkstyle\">\n";
		print "              <input type=\"hidden\" name=\"flag\" value=\"reservebox\">\n";
		print "              <input type=\"hidden\" name=\"targetDay\" value=\"$targetDay\">\n";
		print "              <input type=\"hidden\" name=\"targetID\" value=\"$id\">\n";
		print "            </form>\n";
	}
	else {
		print "            <div>$roomName</div>\n";
	}
	print "          </th>\n";
	my (@targetLines);
	foreach my $line (@reservelines) {
		my (@tmp) = split( /,/, $line );
		my ($rsvDay) = substr( $tmp[0], 0, 8 );
		if ( $rsvDay == $targetDay ) {
			push( @targetLines, $line );
		}
	}
	my ($i) = $begintime;
	foreach (@targetLines) {
		my ( $st, $fn, $nm, $tl, $tmp ) = split( /,/, $_ );
		my ($startTime)  = substr( $st, 8 );
		my ($finishTime) = substr( $fn, 8 );
		while ( $i < $closetime ) {
			if ( $startTime == $i ) {
				my ($rsvTime) = $finishTime - $startTime;
				my ($colspan) = $rsvTime / 0.5;
				print "          <td colspan=$colspan class=\"reserved\" title=\"$nm $tl\"><br /></td>\n";
				$i += $rsvTime;
				last;
			}
			else {
				print "          <td class=\"nonreserved\"><br /></td>\n";
				$i += 0.5;
			}
		}
	}
	while ( $i < $closetime ) {
		print "          <td class=\"nonreserved\"><br /></td>\n";
		$i += 0.5;
	}
	print "        </tr>\n";
	return @targetLines;
}

###############################################################################
# <summary>
#   予約詳細表示
# </summary>
# <param name="lines">部屋の予約リスト</param>
# <remarks></remarks>
###############################################################################
sub show_detail {

	my (@lines) = @_;
	if ( $#lines >= 0 ) {
		print "      <h2><span class=\"rightcaption\">予約詳細</span></h2>\n";
		print "      <table class=\"inputform\">\n";
		print "        <tr>\n";
		print "          <th class=\"cap\">開始時刻</th>\n";
		print "          <th class=\"cap\">終了時刻</th>\n";
		print "          <th class=\"cap\">予約者</th>\n";
		print "          <th class=\"cap\">TEL</th>\n";

		#        print "          <th class=\"cap\">人数</th>\n";
		print "          <th class=\"cap\">予約取り消し<br>(要パスワード)</th>\n";
		print "        </tr>\n";

		foreach my $readLine (@lines) {
			chomp($readLine);
			my ( $st, $fn, $rsvr, $tel, $num ) = split( /,/, $readLine );
			my ($ts) = substr( $st, 8 );
			print "        <form method=\"POST\" action=\"./\">\n";
			print "          <tr>\n";
			if ( $ts =~ /\d\.\d/ ) {
				$ts = ( split( /\./, $ts ) )[0];
				$ts = $ts . ":30";
			}
			else {
				$ts = $ts . ":00";
			}
			print "            <td class=\"reserved\">$ts</td>\n";
			$ts = substr( $fn, 8 );
			if ( $ts =~ /\d\.\d/ ) {
				$ts = ( split( /\./, $ts ) )[0];
				$ts = $ts . ":30";
			}
			else {
				$ts = $ts . ":00";
			}
			print "            <td class=\"reserved\">$ts</td>\n";
			print "            <td class=\"reserved\">$rsvr</td>\n";
			print "            <td class=\"reserved\">$tel</td>\n";

			#            print "            <td class=\"reserved\">$num</td>\n";
			print "            <td class=\"reserved\">\n";
			print "              <input type=\"password\" name=\"inputpw\" size=\"8\" maxlength=\"20\">\n";
			print "              <input type=\"submit\" value=\"予約取り消し\">\n";
			print "            </td>\n";
			print "          </tr>\n";
			print "          <input type=\"hidden\" name=\"flag\" value=\"cancel\">\n";
			print "          <input type=\"hidden\" name=\"targetID\" value=\"$targetID\">\n";
			print "          <input type=\"hidden\" name=\"delID\" value=\"$st\">\n";
			print "        </form>\n";
		}
		print "      </table>\n";
	}

}

###############################################################################
# <summary>
#   予約日選択リスト
# </summary>
# <remarks></remarks>
###############################################################################
sub show_daypick {

	my ($thisyear) = substr( $today, 0, 4 );
	my ($thismon)  = substr( $today, 4, 2 );
	my ($thisday);
	my ($i);
	if ( $thismon == 12 ) {
		$thisyear += 1;
	}
	else {
		$thismon += 1;
	}
	print "    <br />\n";
	print "    <br />\n";
	print "    <form name=\"dayPick\" method=\"POST\" action=\"./\">\n";
	print "      <select name=\"targetDay\" onChange=\"document.dayPick.submit()\">\n";
	print "        <option value=\"\">予約日選択</option>\n";
	for ( $i = 1 ; $i <= 31 ; $i++ ) {
		next unless ( &DateExists( $thisyear, $thismon, $i ) );
		$thisyear = sprintf( "%02d", $thisyear );
		$thismon  = sprintf( "%02d", $thismon );
		$thisday  = sprintf( "%02d", $i );
		my ($d) = $thisyear . $thismon . $thisday;
		if ( $d == $targetDay ) {
			print "        <option value=\"$d\" selected>$thisyear年$thismon月$thisday日</option>\n";
		}
		else {
			print "        <option value=\"$d\">$thisyear年$thismon月$thisday日</option>\n";
		}
	}
	print "      </select>\n";
	print "      <noscript>\n";
	print "        <input type=\"submit\" value=\"予約用に表示\">\n";
	print "      </noscript>\n";
	print "      <input type=\"hidden\" name=\"flag\" value=\"formadmin\">\n";
	print "      <input type=\"hidden\" name=\"mngrpw\" value=\"$mngrpw\">\n";
	print "      <input type=\"hidden\" name=\"targetID\" value=\"$targetID\">\n";
	print "    </form>\n";
}

###############################################################################
# <summary>
#   管理者ログインフォーム
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub show_manageinput {

	# 管理用フォーム
	print "    <div>\n";
	print "      <form name=\"F1\" method=\"POST\" action=\"#\">\n";
	print "        <table class=\"admintable\">\n";
	print "          <tr>\n";
	print "            <td class=\"adminright\">\n";
	print "              <div>リスト</div>\n";
	print "            </td>\n";
	print "            <td class=\"adminleft\">\n";
	print "              <select name=\"targetID\" style=\"width:120px;\">\n";

	foreach (@itemlist) {
		my (@tmp) = split( /,/, $_ );
		print "                <option value=\"$tmp[0]\">$tmp[1]</option>\n";
	}
	print "                <option value=\"sys\">システム管理者</option>\n";
	print "              </select>\n";
	print "            </td>\n";
	print "          </tr>\n";
	print "          <tr>\n";
	print "            <td class=\"adminright\">\n";
	print "              <div>パスワード</div>\n";
	print "            </td>\n";
	print "            <td class=\"adminleft\">\n";
	print "              <input type=\"password\" name=\"mngrpw\" style=\"width:110px;\" />\n";
	print "            </td>\n";
	print "          </tr>\n";
	print "          <tr>\n";
	print "            <td><br /></td>\n";
	print "            <td class=\"adminleft\">\n";
	print "              <input type=\"button\" value=\"管理者ログイン\" onClick=\"wPost()\" />\n";
	print "            </td>\n";
	print "          </tr>\n";
	print "        </table>\n";
	print "        <input type=\"hidden\" name=\"flag\" />\n";
	print "      </form>\n";
	print "    </div>\n";
}

###############################################################################
# <summary>
#   予約入力フォーム
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub show_inputform {

	&getcookie;
	my ($i);
	my ($j);
	print "    <h2><span class=\"rightcaption\">予約</span></h2>\n";
	print "    <form method=\"POST\" action=\"./\">\n";
	print "      <table class=\"inputform\">\n";
	print "        <tr>\n";
	print "          <th class=\"cap\" colspan=\"2\">" . ( split( /,/, $roomInfo{$targetID} ) )[1] . "</th>\n";
	print "        </tr>\n";
	print "        <tr>\n";
	print "          <th class=\"cap\">管理者</th>\n";
	print "          <th class=\"cap\">" . ( split( /,/, $roomInfo{$targetID} ) )[2] . "</th>\n";
	print "        </tr>\n";
	print "        <tr>\n";
	print "          <th class=\"cap\">予約日</th>\n";
	print "          <td class=\"cap\">\n";
	print "            " . substr( $targetDay, 0, 4 ) . "年" . substr( $targetDay, 4, 2 ) . "月" . substr( $targetDay, 6, 2 ) . "日\n";
	print "          </td>\n";
	print "        </tr>\n";
	print "        <tr>\n";
	print "          <th class=\"cap\">開始時刻</th>\n";
	print "          <td class=\"cap\">\n";
	print "            <select name=\"st_h\">\n";

	for ( $i = $begintime ; $i < $closetime ; $i++ ) {
		$j = sprintf( "%02d", $i );
		print "              <option value=\"$j\">$i</option>\n";
	}
	print "            </select>\n";
	print "            時\n";
	print "            <select name=\"st_m\">\n";
	print "              <option value=\"\">00</option>\n";
	print "              <option value=\".5\">30</option>\n";
	print "            </select>\n";
	print "            分\n";
	print "          </td>\n";
	print "        </tr>\n";
	print "        <tr>\n";
	print "          <th class=\"cap\">終了時刻</th>\n";
	print "          <td class=\"cap\">\n";
	print "            <select name=\"fn_h\">\n";

	for ( $i = $begintime ; $i <= $closetime ; $i++ ) {
		$j = sprintf( "%02d", $i );
		print "              <option value=\"$j\">$i</option>\n";
	}
	print "            </select>\n";
	print "            時\n";
	print "            <select name=\"fn_m\">\n";
	print "              <option value=\"\">00</option>\n";
	print "              <option value=\".5\">30</option>\n";
	print "            </select>\n";
	print "            分\n";
	print "          </td>\n";
	print "        </tr>\n";

	#	print "        <tr>\n";
	#	print "          <th class=\"cap\">使用人数</th>\n";
	#	print "          <td class=\"cap\">\n";
	#	print "            <select name=\"num\">\n";
	#	for ( $i = 1 ; $i < 10 ; $i++ ) {
	#		print "              <option>$i</option>\n";
	#	}
	#	print "              <option>10人以上</option>\n";
	#	print "            </select>\n";
	#	print "          </td>\n";
	#	print "        </tr>\n";
	print "        <tr>\n";
	print "          <th class=\"cap\">予約者</th>\n";
	print "          <td class=\"cap\"><input type=\"text\" name=\"reserver\" value=\"$cookiereserver\" maxlength=\"30\"></td>\n";
	print "        </tr>\n";
	print "        <tr>\n";
	print "          <th class=\"cap\">TEL</th>\n";
	print "          <td class=\"cap\"><input type=\"text\" name=\"tel\" value=\"$cookietel\" maxlength=\"15\"></td>\n";
	print "        </tr>\n";
	print "        <tr>\n";
	print "          <th class=\"cap\">パスワード</th>\n";
	print "          <td class=\"cap\"><input type=\"password\" name=\"inputpw\" maxlength=\"20\"></td>\n";
	print "        </tr>\n";
	print "        <tr>\n";
	print "          <th colspan=\"2\" class=\"cap\"><input type=\"submit\" name=\"submit\" value=\"予約\"></td>\n";
	print "        </tr>\n";
	print "      </table>\n";
	print "      <input type=\"hidden\" name=\"flag\" value=\"reserve\">\n";
	print "      <input type=\"hidden\" name=\"targetDay\" value=\"$targetDay\">\n";
	print "      <input type=\"hidden\" name=\"targetID\" value=\"$targetID\">\n";
	print "      <input type=\"hidden\" name=\"mngrpw\" value=\"$mngrpw\">\n";
	print "    </form>\n";
}

###############################################################################
# <summary>
#   著作権、広告表示
# </summary>
# <remarks>絶対消さないように</remarks>
###############################################################################
sub show_iframe {

	# 著作権表示
	# ここは著作権表示です必ず表示させてお使いください。
	print "    <div class=\"copyright\">\n";
	my ($hpnum) = int( rand(4) );
	print "      <br />\n";
	print "      <br />\n";
	print "      <span style=\"font-size: medium;	font-weight: lighter;\">Copyright by <a href=\"http://lookinfor.jp/\" target=\"_blank\">Lookin'For...</a></span>\n";
	print "    </div>\n";
	print "    <div class=\"copyright\">\n";
	print "      <iframe src=\"http://lookinfor.jp/amazon/reserve/" . $hpnum . ".html\" frameborder=\"0\" allowtransparency=\"true\" id=\"iframe\"> この部分は iframe 対応のブラウザで見てください。 </iframe>\n";
	print "    </div>\n";

	# /著作権表示

}

###############################################################################
# <summary>
#   予約記録
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub write_data {

	my ($ret)        = 'false';
	my ($targetFile) = "./data/" . $targetID . ".dat";
	my ($startTime)  = $targetDay . $st_h . $st_m;
	my ($finishTime) = $targetDay . $fn_h . $fn_m;

	# 開始＆終了時刻チェック
	if ( $startTime >= $finishTime ) {
		print "    <div><span class=\"errormsg\">開始時刻と終了時刻が正しくありません。</span></div>\n";
		return;
	}

	# 終了時刻チェック
	if ( ( $fn_h == $closetime ) && ( $fn_m eq ".5" ) ) {
		print "    <div><span class=\"errormsg\">終了時刻が正しくありません。</span></div>\n";
		return;
	}

	# 空欄チェック
	if ( ( $reserver eq "" ) || ( $inputpw eq "" ) || ( $tel eq "" ) ) {
		print "    <div><span class=\"errormsg\">入力モレがあります。</span></div>\n";
		return;
	}

	# パスワード文字チェック
	unless ( $inputpw =~ /[0-9a-zA-Z]/ ) {
		print "    <div><span class=\"errormsg\">パスワードは半角英数のみ使用可です。</span></div>\n";
		return;
	}

	#文字数チェック
	if ( length($reserver) > 50 ) {
		print "    <div><span class=\"errormsg\">使用者の入力バイト数は、50バイト(全角25文字)以下にしてください。</span></div>\n";
		return;
	}
	elsif ( length($inputpw) > 20 ) {
		print "    <div><span class=\"errormsg\">パスワードの入力バイト数は、20文字以下にしてください。</span></div>\n";
		return;
	}
	elsif ( length($tel) > 30 ) {
		print "    <div><span class=\"errormsg\">電話番号の入力バイト数は、30バイト(全角15文字)以下にしてください。</span></div>\n";
		return;
	}

	# 日付チェック (来月の予約は、解禁日以降またはパスワードが正しい)
	my ($today) = &getToday;
	if ( substr( $targetDay, 4, 2 ) != substr( $today, 4, 2 ) ) {
		if ( substr( $today, 6, 2 ) < $ban ) {
			my ($roompw) = ( split( /,/, $roomInfo{$targetID} ) )[3];
			if ( $mngrpw ne $roompw ) {
				print "    <div><span class=\"errormsg\">翌月の予約は、まだ解禁されていません。</span></div>\n";
				return;
			}
		}
	}

	# 書き込み
	my ($lockfile) = "./data/" . $targetID . ".loc";
	my ($tempfile) = "./data/" . $targetID . ".tmp";
	my ($crypted)  = &pw_create($inputpw);
	my ($inline)   = "$targetDay$st_h$st_m,$targetDay$fn_h$fn_m,$reserver,$tel,$num,$crypted,,,\n";
	my ($chk);
	my (@newline);
	open( LOCK, ">$lockfile" );
	flock( LOCK, 2 );

	while (1) {
		my (@lines);
		open( IN, "+<$targetFile" ) || last;
		@lines = <IN>;
		close(IN);
		if ( $#lines >= 0 ) {
			my ($lastFn);
			foreach my $line (@lines) {
				my (@tmp) = split( /,/, $line );
				if ( ( $startTime >= $lastFn ) && ( $finishTime <= $tmp[0] ) ) {
					push( @newline, $inline );
					$chk = 1;
				}
				push( @newline, $line );
				$lastFn = $tmp[1];
			}
			if ( $startTime >= $lastFn ) {
				push( @newline, $inline );
				$chk = 1;
			}
		}
		else {
			push( @newline, $inline );
			$chk = 1;
		}
		if ( $chk == 1 ) {
			open( OUT, ">$tempfile" ) || last;
			print OUT join( "", @newline ) || last;
			close(OUT);
			rename( $tempfile, $targetFile );
			print "    <div><span class=\"errormsg\">正しく予約されました。</span></div>\n";
			$ret = 'true';
		}
		else {
			print "    <div><span class=\"errormsg\">予約できませんでした。内容を見直してください。</span></div>\n";
		}
		last;
	}
	close(LOCK);
	return $ret;
}

###############################################################################
# <summary>
#   予約キャンセル
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub delete_data {

	# パスワードチェック

	my ($lockfile)   = "./data/" . $targetID . ".loc";
	my ($tempfile)   = "./data/" . $targetID . ".tmp";
	my ($targetFile) = "./data/" . $targetID . ".dat";
	my ($roompw)     = ( split( /,/, $roomInfo{$targetID} ) )[3];
	my ( @lines, @newLine );
	my ($chk) = 0;
	open( LOCK, ">$lockfile" );
	flock( LOCK, 2 );
	while (1) {
		open( IN, "+<$targetFile" ) || last;
		@lines = <IN>;
		close(IN);

		#
		foreach my $line (@lines) {
			my (@tmp) = split( /,/, $line );
			chomp( $tmp[5] );
			if ( $delID eq $tmp[0] ) {
				if ( ( $tmp[5] eq crypt( $inputpw, $tmp[5] ) ) || ( $inputpw eq $roompw ) ) {
					$chk = 1;
				}
				else {
					push( @newLine, $line );
				}
			}
			else {
				push( @newLine, $line );
			}
		}

		#
		my ($writeline);
		if ( $#newLine >= 0 ) {
			$writeline = join( "", @newLine );
		}
		else {
			$writeline = "";
		}
		if ( $chk == 1 ) {
			open( OUT, ">$tempfile" ) || last;
			if ( $writeline ne "" ) {
				print OUT $writeline || last;
			}
			close(OUT);
			rename( $tempfile, $targetFile );
			print "    <div><span class=\"errormsg\">予約をキャンセルしました。</span></div>\n";
		}
		else {
			print "    <div><span class=\"errormsg\">予約をキャンセルできませんでした。</span></div>\n";
		}
		last;
	}
	close(LOCK);
}

###############################################################################
# <summary>
#   パスワード作成
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub pw_create {
	my ($in) = $_[0];
	srand();
	my (@salts)   = ( "A" .. "Z", "a" .. "z", "0" .. "9", ".", "/" );
	my ($salt)    = $salts[ int( rand(64) ) ] . $salts[ int( rand(64) ) ];
	my ($crypted) = crypt( $in, $salt );
	return $crypted;
}

###############################################################################
# <summary>
#   今日の日付を取得
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub getToday {
	my ( $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst ) = localtime(time);
	$year = $year + 1900;
	$mon  = $mon + 1;

	#	my (@youbi) = ( "日", "月", "火", "水", "木", "金", "土" );
	#	my ($youbi) = $youbi[$wday];
	#	my ($time)  = "$year年$mon月$mday日($youbi)$hour時$min分$sec秒";
	my ($td) = "$year" . sprintf( "%02d", $mon ) . sprintf( "%02d", $mday );
	return $td;
}

###############################################################################
# <summary>
#   日付存在チェック
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub DateExists {
	my ( $year, $mon, $day ) = @_;
	eval { timelocal( 0, 0, 0, $day, $mon - 1, $year - 1900 ); };
	if ($@) { return "0"; }
	if ( $mon == 12 ) { $mon = 0; }
	my $time = timelocal( 0, 0, 0, 1, $mon, $year - 1900 );
	$time -= 60 * 60 * 24;
	my @date = localtime($time);
	if ( $day > $date[3] ) { return 0; }
	return 1;
}

###############################################################################
# <summary>
#   ファイル読み込み
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub open_file {
	my (@lines);
	my ($fname) = @_;
	unless ( -e $fname ) {
		open( OUT, ">$fname" );
		print OUT "";
		close(OUT);
	}
	open( IN, $fname ) || die print "$fname のオープンに失敗しました";
	eval("flock (IPCHK, 2 )");
	@lines = <IN>;
	close(IN);
	return @lines;
}

###############################################################################
# <summary>
#   カレンダー表示用
# </summary>
# <remarks></remarks>
###############################################################################
sub show_calendar {

	# カレンダー
	my ($mon)  = ( localtime(time) )[4];
	my ($year) = ( localtime(time) )[5];
	&calendar( timelocal( 0, 0, 0, 1, $mon, $year ), 2 );
}

###############################################################################
# <summary>
#   カレンダー表示
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub calendar {

	my ( $sdayseri, $count ) = @_;
	my ($iflag) = 0;
	while ( $iflag < $count ) {
		my ($tmp_mon)  = ( localtime($sdayseri) )[4];
		my ($tmp_year) = ( localtime($sdayseri) )[5];

		#翌月の初日のシリアル
		if ( $tmp_mon == 11 ) {
			$tmp_mon  = 0;
			$tmp_year = $tmp_year + 1;
		}
		else {
			$tmp_mon  = $tmp_mon + 1;
			$tmp_year = $tmp_year;
		}
		my ($sdaynxtseri) = timelocal( 0, 0, 0, 1, $tmp_mon, $tmp_year );

		#該当月の初日の曜日
		my ($sdaywk) = ( localtime($sdayseri) )[6];

		#該当月の最終日のシリアル
		my ($edayseri) = $sdaynxtseri - ( 60 * 60 * 24 );

		#該当月の最終日
		my ($eday) = ( localtime($edayseri) )[3];

		#該当月の最終日の曜日
		my ($edaywk)    = ( localtime($edayseri) )[6];
		my ($total_day) = $sdaywk + $eday + ( 6 - $edaywk );
		my ($thisyear)  = 1900 + ( localtime($sdayseri) )[5];
		my ($thismon)   = 1 + ( localtime($sdayseri) )[4];
		print "    <h2><span class=\"leftcaption\">$thisyear年$thismon月</span></h2>\n";
		print "    <table class=\"calendar\">\n";
		print "      <tr>\n";
		print "        <th class=\"sunday\">日</th>\n";
		print "        <th class=\"weekday\">月</th>\n";
		print "        <th class=\"weekday\">火</th>\n";
		print "        <th class=\"weekday\">水</th>\n";
		print "        <th class=\"weekday\">木</th>\n";
		print "        <th class=\"weekday\">金</th>\n";
		print "        <th class=\"saturday\">土</th>\n";
		print "      </tr>\n";

		#
		my ($i) = 1;
		my ($j) = 1;
		my ($class);
		while ( $i < $total_day + 1 ) {
			my ($tgtday) = $thisyear . sprintf( "%02d", $thismon ) . sprintf( "%02d", $j );
			$class = "weekday";
			$class = "sunday" if ( ( $i % 7 ) == 1 );
			$class = "saturday" if ( ( $i % 7 ) == 0 );

			#			$class = "today" if ( ( $iflag == 0 ) && ( $j == ( localtime(time) )[3] ) );
			$class = "today" if ( $targetDay eq $tgtday );
			if ( ( $i % 7 ) == 1 ) {
				print "      <tr>\n";
			}
			if ( ( $j > $eday ) || ( $i <= $sdaywk ) ) {
				print "        <td class=\"nonreserved\"><br /></td>\n";
			}
			else {

				#				my ($tgtday) = $thisyear . sprintf( "%02d", $thismon ) . sprintf( "%02d", $j );
				print "        <th class=\"$class\">\n";
				print "          <form method=\"POST\" action=\"./\">\n";
				print "            <input type=\"submit\" value=\"$j\" class=\"linkstyle\">\n";
				print "            <input type=\"hidden\" name=\"targetDay\" value=\"$tgtday\">\n";
				print "          </form>\n";
				print "        </th>\n";
				$j++;
			}
			if ( ( $i % 7 ) == 0 ) {
				print "      </tr>\n";
			}
			$i++;
		}
		print "    </table>\n";
		$sdayseri = $sdaynxtseri;
		$iflag++;
	}
}

###############################################################################
# <summary>
#   ヘッダー
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub header {

	print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n";
	print "<html>\n";
	print "<head>\n";
	print "  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
	print "  <title>$title</title>\n";
	print "  <link href=\"./style.css\" rel=\"stylesheet\" type=\"text/css\">\n";
	print "    <script type=\"text/javascript\">\n";
	print "    <!--\n";
	print "      function wPost() {\n";
	print "        var page = document.F1.targetID.value;\n";
	print "        if ( page == 'sys' ) {\n";
	print "          document.F1.action = \"./manage.cgi\";\n";
	print "        } else {\n";
	print "          document.F1.action = \"./index.cgi\";\n";
	print "          document.F1.flag.value = \"admin\";\n";
	print "        }\n";
	print "        document.F1.submit();\n";
	print "      }\n";
	print "    // -->\n";
	print "   </script>\n";
	print "</head>\n";
	print "<body>\n";
}

###############################################################################
# <summary>
#   フッター
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub footer {
	print "</body>\n";
	print "</html>\n";
}

###############################################################################
# <summary>
#   クｋッキー取得
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub getcookie {

	my ($cookie) = $ENV{'HTTP_COOKIE'};
	$cookie =~ s/.*RRSystem=//;
	( $cookiereserver, $cookietel, ) = split( /\,/, $cookie );

}

###############################################################################
# <summary>
#   変数デコード
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub init_form {
	my ( $query, @assocarray, $assoc, $property, $value, $method );
	$method = $ENV{'REQUEST_METHOD'};
	$method =~ tr/A-Z/a-z/;
	if ( $method eq 'post' ) {
		read( STDIN, $query, $ENV{'CONTENT_LENGTH'} );
	}
	else {
		$query = $ENV{'QUERY_STRING'};
	}
	@assocarray = split( /&/, $query );
	foreach $assoc (@assocarray) {
		( $property, $value ) = split( /=/, $assoc );
		$value =~ tr/+/ /;
		$value =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C", hex($1))/eg;
		&jcode'convert( *value, "utf-8" );    # '
		$value =~ s/&/&amp;/g;
		$value =~ s/"/quot;/g;
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		$value =~ s/\t//g;
		$value =~ s/\r//g;
		$value =~ s/\,/&#44;/g;
		$form{$property} = $value;
	}
}
